typedef
enum{
	Echar=0,
	Edouble,
	Efloat,
	Eint,	
	Elong,
	Eshort,
	Esigned,
	Eunsigned,
	Evoid,
	Enbase,
	Enull,
} Kind;

/* base C types */
typedef
enum Cbase {
	Vundef=0,
	Vchar,
	Vshort,
	Vint,
	Vlong,
	Vvlong,
	Vuchar,
	Vushort,
	Vuint,
	Vulong,
	Vuvlong,
	Vfloat,
	Vdouble,
	Vlongdouble,
	Vvoid,
	Vnbase,
	Vnallbase,
} Cbase;

extern char* cbname [];

enum DW_bytesizes {
  DW_one = 0,
  DW_two = 1,
  DW_four = 2,
  DW_eight = 3,
  DW_bytesize_cnt = 4,
} DW_bytesizes;

extern enum DW_bytesizes mapsizes (int);
extern unsigned stdbasetype [DW_bytesize_cnt][9];

typedef
struct Src {
	char *filename;
	unsigned col, line;
} Src;

typedef struct Expr Expr;

struct Expr {
	Kind kind;

	char *id;		/* Eid, Etick */
#if 0  
	Lits *lits;		/* Econsts */
	Liti liti;		/* Econst */
#endif
	Kind op;		/* Ebinop, Egop */

	Expr *e1;
	Expr *e2;
	Expr *e3;
	Expr *e4;

	/* source */
	Src src;

	/* compiler-managed fields */
	void *xp;
	unsigned xn;
};

extern Expr * stdbasepart (char *);
extern Expr * isstdbasetype (char *);
extern Cbase baselist(Expr *);
extern char * get_cbname (unsigned int);
