typedef struct Hent Hent;
typedef struct HT HT;

struct Hent {
	char *key;
	unsigned keylen;
	void *val;
	Hent *next;
};


struct HT {
	unsigned long sz;
	unsigned long nent;
	Hent **ht;
};

HT *mkht();
void freeht(HT *ht);
void hput(HT *ht, char *k, unsigned len, void *v);
void *hget(HT *ht, char *k, unsigned len);
void hforeach(HT *ht, void (*f)(void *u, char *k, void *v), void *u);
int wasseen(HT *ht, char *s);
void freeseen(HT *ht);
